using UnityEngine;
using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;


namespace Mod
{
    public class Mod
    {
        public static void Main()
        {


             CategoryBuilder.Create("Spies", "",ModAPI.LoadSprite("category.png"));
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hitman <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>For 12k dollars i can kill anyone you named...",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/HitmanView1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/Hitmanskin1.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );

             CategoryBuilder.Create("Spies", "",ModAPI.LoadSprite("category.png"));
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "TF2 Spy RedSmoking  <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>...",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/SPY1TF2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/TF2 Spy1.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );            

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "PoggoDoggo Spia", 
                    NameToOrderByOverride = "hair",
                    DescriptionOverride = "Don't mess with me Marcello...", 
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Poggothumb.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        var skin = ModAPI.LoadTexture("people/Poggo.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/Fleshbody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
                        var person = Instance.GetComponent<PersonBehaviour>();
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(head);
                        cObj.transform.localPosition = new Vector3(-0.09f, -0.9500f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(1f, 1f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("People/poggohad.png");
                        cSpr.sortingLayerName = "Top";
                        AudioSource audioSource;
                        AudioClip sound;
                        sound = ModAPI.LoadSound("sfx/BF.wav");
                        audioSource = Instance.AddComponent<AudioSource>();
                        audioSource.minDistance = 20;
                        audioSource.maxDistance = 100;
                        audioSource.clip = sound;
                        audioSource.Play();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Marcello Spia", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = "Please! STOP POGGO!", //new item description
        CategoryOverride = ModAPI.FindCategory("Spies"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Marcellothumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("people/Marcelloskin.png");
                        var flesh = ModAPI.LoadTexture("null");
                        var bone = ModAPI.LoadTexture("null");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(138, 63, 63); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(54, 1, 3); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);
             CategoryBuilder.Create("Spies", "",ModAPI.LoadSprite("category.png"));
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "TF2 Spy BlueSmoking  <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>...",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/SPY2TF2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/TF2 Spy2.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );                        

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hitman1 <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>For 16k dollars i can kill everyone you want...",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/HitmanView2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/Hitmanskin2.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Money -SPIES",
                    DescriptionOverride = "Moneyy",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/MoneyThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/Money.png");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.TrueInitialMass = 0.003f;
                        phys.InitialMass = 0.003f;
                        phys.rigidbody.mass = 0.003f;
                        var properties = ModAPI.FindPhysicalProperties("Bowling pin");
                        properties.name = "Paper";
                        properties.Buoyancy = 1f;
                        properties.Flammability = 100f;
                        properties.Brittleness = 100f;
                        properties.BulletSpeedAbsorptionPower = 0.005f;
                        properties.Burnrate = 1f;
                        properties.Softness = 0.95f;
                        properties.SoftImpact = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/Paper1.mp3"),
                            ModAPI.LoadSound("sfx/Paper2.mp3"),
                            ModAPI.LoadSound("sfx/Paper3.mp3")
                        };
                        properties.HardImpact = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/Paper1.mp3"),
                            ModAPI.LoadSound("sfx/Paper2.mp3"),
                            ModAPI.LoadSound("sfx/Paper3.mp3")
                        };
                        properties.StabSound = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/Paper1.mp3"),
                            ModAPI.LoadSound("sfx/Paper2.mp3"),
                            ModAPI.LoadSound("sfx/Paper3.mp3")
                        };
                        phys.Properties = properties;

                        Instance.FixColliders();
                    }
                }
            );

                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hitman2 <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>For 30k dollars i can kill everyone you want or make them disappear...",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/HitmanView3.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/Hitmanskin3.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );

                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hitman3 <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>For 50k dollars i can kill everyone, make them disappear and give to you all his stuff...",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/HitmanView4.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/Hitmanskin4.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );

                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hitman4 Waiter <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>What do you order?...",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/HitmanView5.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/Hitmanskin5.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );

                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hitman5 Fake Doctor <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>Trust me, i can health you eheheh...",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/HitmanView6.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/Hitmanskin6.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );

                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hitman7 <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>Im just a guy with a blue smoking, nothing more... right?",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/HitmanView7.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/Hitmanskin7.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );

                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hitman8 <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>Im just a guy with a red smoking, nothing more... right?",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/HitmanView8.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/Hitmanskin8.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );

                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hitman9 <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>Im just a guy with a gray smoking, nothing more... right?",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/HitmanView9.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/Hitmanskin9.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );

                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "The Guest <color=yellow>-SPIES",
                    DescriptionOverride = "<color=white>I escape from a laboratory. I ALWAYS COME BACK...",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/TheGuestThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("people/TheGuest.png");
                        var flesh = ModAPI.LoadTexture("NPCs normal/FleshBody.png");
                        var bone = ModAPI.LoadTexture("NPCs normal/bone.png");
						var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone);
                        foreach (var body in person.Limbs)
                        {
                            body.transform.root.localScale *= 1;
                        }
                    }
                }
            );            

            //USPS
            ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "OAL",
                    NameToOrderByOverride = "OALPISTOL",
                    DescriptionOverride = "Suppressed semi-automatic pistol", 
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/oalhumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects();

                        var GunSlide = Instance.transform.Find("Slide");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("FireArms/Pistol silenced.png", 0.9f);
                        GunSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slide/Pistol silenced.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "OAL";
                        customCartridge.Damage = 10f;
                        customCartridge.Recoil = 0.6f;
                        customCartridge.ImpactForce  = 0.3f;
                        firearm.Cartridge = customCartridge;
                        firearm.casingPosition = new Vector2(-0.1f, 0.0f);

                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.33f, 0.083f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
                        var sound = Instance.GetComponent<FirearmBehaviour>();
                        sound.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/USPS-1.wav"),
                            ModAPI.LoadSound("sfx/USPS-2.wav"),
                            ModAPI.LoadSound("sfx/USPS-3.wav"),
                        };

                        Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new[]
{
                            new Vector3(-0.18f, -0.04f)
                        };

                    }
                }
            );
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Hat Red -SPIES",
        DescriptionOverride = "Is just a red hat",
        CategoryOverride = ModAPI.FindCategory("Spies"),
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/HatThumb.png"),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hats/hat.png");
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("ExampleArmor.pg");
            Instance.FixColliders();
        }  
    }
);


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Hat White -SPIES",
        DescriptionOverride = "Is just a White hat",
        CategoryOverride = ModAPI.FindCategory("Spies"),
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Hat1Thumb.png"),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hats/hat1.png");
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("ExampleArmor.pg");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Hat Black -SPIES",
        DescriptionOverride = "Is just a Black hat",
        CategoryOverride = ModAPI.FindCategory("Spies"),
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Hat2Thumb.png"),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hats/hat2.png");
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("ExampleArmor.pg");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Hat Blue -SPIES",
        DescriptionOverride = "Is just a Blue hat",
        CategoryOverride = ModAPI.FindCategory("Spies"),
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Hat3Thumb.png"),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hats/hat3.png");
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("ExampleArmor.pg");
            Instance.FixColliders();
        }  
    }
);

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Knife -SPIES",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    DescriptionOverride = "A Knife from a distant time.",
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/KnifeThumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Knife/Knife.png", 2f);
                    }
                }
            );

            
ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Revolver"),
                 NameOverride = "Colt Model 1851 Revolver -SPIES",
                 NameToOrderByOverride = "6",
                 DescriptionOverride = "Gun",
                 CategoryOverride = ModAPI.FindCategory("Spies"),
                 ThumbnailOverride = ModAPI.LoadSprite("thumbnails/RevolverThumb.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("FireArms/Revolver.png", 1f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                     customCartridge.name = "9mm";
                     customCartridge.Damage *= 3f;
                     customCartridge.StartSpeed *= 2f;
                     customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                     customCartridge.Recoil *= 4f;
                     customCartridge.ImpactForce *= 3f;
                     firearm.Cartridge = customCartridge;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("sfx/Revolvershot.wav"),
                     };
                 }
             }
             ); ;

                         //Silenced Sniper
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Suppressed Sniper -SPIES",
                    NameToOrderByOverride = "Sniper",
                    DescriptionOverride = "Boom. Headshot (But quiet!)",
                    CategoryOverride = ModAPI.FindCategory("Spies"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/SNIPERTHUMB.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("FireArms/Sniper.png", 1f);
                        Instance.FixColliders();
                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.InitialInaccuracy = 0f;
                        firearm.BulletsPerShot = 1;
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/snipergunshot.mp3")
                            
                            
                        };
                    }
                }
            );

                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"), //item to derive from
                    NameOverride = "Broken Bottle -SPIES", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Don't get glass in your fingers!", //new item description
                    CategoryOverride = ModAPI.FindCategory("Spies"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Bottlethumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Knife/Bottle.png", 1.2f);
                        Instance.FixColliders();
                    }
                }
            );

                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"), //item to derive from
                    NameOverride = "Mini Knifes -SPIES", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = " Be Quiet", //new item description
                    CategoryOverride = ModAPI.FindCategory("Spies"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Mini-Knifethumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Knife/Mini-Knife.png", 1.2f);
                        Instance.FixColliders();
                    }
                }
            );

        }
    }
}